/**
 * Game.java
 * 3/30/12
 */

import java.awt.Dimension;
import java.awt.Graphics;
import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 * A simple game.
 * 
 * @author CPSC170A
 */
public class Game extends JPanel implements Runnable {

    /** Number of milliseconds in a second. */
    private static final long MILLI_IN_SEC = 1000;

    /** Panel width. */
    public static final int PANEL_WIDTH = 640;

    /** Panel height. */
    public static final int PANEL_HEIGHT = 480;

    /** System time of last frame. */
    private long previousTime;

    /** Number of frames elapsed this second. */
    private int frameCnt = 0;

    /** Number of milliseconds elapsed this second. */
    private long timeCnt = 0;

    /** Program window. */
    private JFrame frame;

    /**
     * Runs the application.
     * 
     * @param args command line argument
     */
    public static void main(final String[] args) {
        new Game();
    }

    /**
     * Constructor, initializes the the game.
     */
    public Game() {
        Thread thread = new Thread(this);
        frame = new JFrame("Game - ???fps");
	previousTime = System.currentTimeMillis();
        setPreferredSize(new Dimension(PANEL_WIDTH, PANEL_HEIGHT));
        frame.getContentPane().add(this);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.pack();
        frame.setVisible(true);
        thread.start();
    }

    /**
     * Draw the sprites in the game.
     * 
     * @param g graphics object to draw to
     */
    public final void paintComponent(final Graphics g) {
        super.paintComponent(g);
	// TODO: implement paint
    }

    /**
     * Update this level based on the amount of time that has elapsed since the
     * last update.
     * 
     * @param elapsedTime the amount of time that has elapsed since the last
     *            update
     */
    public final void update(final long elapsedTime) {
	// TODO: implement update
    }

    /**
     * Run loop for the game.
     */
    public final void run() {
        long currentTime;
        long elapsedTime;
        boolean running = true;
        while (running) {
            currentTime = System.currentTimeMillis();
            elapsedTime = currentTime - previousTime;
            previousTime = currentTime;
            timeCnt += elapsedTime;
            frameCnt++;
            if (timeCnt > MILLI_IN_SEC) {
                frame.setTitle("Game - " + frameCnt + "fps");
                frameCnt = 0;
                timeCnt = 0;
            }
            update(elapsedTime);
	    repaint();
            try {
                Thread.sleep(1);
            } catch (Exception e) {
                System.out.println("Error sleeping.");
                running = false;
            }
        }
    }

}
